package com.qiaomeng.flutter.request_install_packages;

import android.Manifest;
import android.app.Activity;
import android.app.Application;
import android.content.Intent;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.provider.Settings;

import androidx.annotation.Nullable;
import androidx.annotation.RequiresApi;
import androidx.core.app.ActivityCompat;

import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.PluginRegistry;

public class Handler {
    static final int REQUESE_CODE = 65531;
    Activity mActivity;
    ActivityPluginBinding activityPluginBinding;
    PluginRegistry.ActivityResultListener activityResultListener;

    public void setActivityPluginBinding(ActivityPluginBinding activityPluginBinding) {
        if (this.activityPluginBinding != null || activityPluginBinding == null) {
            return;
        }
        this.activityPluginBinding = activityPluginBinding;
        activityPluginBinding.addActivityResultListener(new PluginRegistry.ActivityResultListener() {
            @Override
            public boolean onActivityResult(int requestCode, int resultCode, Intent data) {
                if (activityResultListener != null) {
                    return activityResultListener.onActivityResult(requestCode, resultCode, data);
                }

                return true;
            }
        });
    }

    public void setActivity(Activity activity) {
        if (this.mActivity != null || activity == null) {
            return;
        }
        this.mActivity = activity;
        this.mActivity.getApplication().registerActivityLifecycleCallbacks(new Application.ActivityLifecycleCallbacks() {
            @Override
            public void onActivityCreated(Activity activity, Bundle savedInstanceState) {
                mActivity = activity;
            }

            @Override
            public void onActivityStarted(Activity activity) {
                mActivity = activity;
            }

            @Override
            public void onActivityResumed(Activity activity) {
                mActivity = activity;
            }

            @Override
            public void onActivityPaused(Activity activity) {

            }

            @Override
            public void onActivityStopped(Activity activity) {

            }

            @Override
            public void onActivitySaveInstanceState(Activity activity, Bundle outState) {

            }

            @Override
            public void onActivityDestroyed(Activity activity) {

            }
        });
    }

    public void check(MethodChannel.Result result) {
        boolean haveInstallPermission = true;
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            haveInstallPermission = mActivity.getPackageManager().canRequestPackageInstalls();
        }
        result.success(haveInstallPermission);
    }

    public void request(final MethodChannel.Result result) {
        activityResultListener = new PluginRegistry.ActivityResultListener() {
            @Override
            public boolean onActivityResult(int requestCode, int resultCode, Intent data) {
                if (requestCode != REQUESE_CODE) {
                    return false;
                }
                check(result);
                return true;
            }
        };

//        ActivityCompat.requestPermissions(mActivity,new String[]{Manifest.permission.REQUEST_INSTALL_PACKAGES},REQUESE_CODE);

        Thread thread = new Thread(new Runnable() {
            @Override
            public void run() {
                Uri packageURI = Uri.parse("package:" + mActivity.getPackageName());
                Intent intent = new Intent(Settings.ACTION_MANAGE_UNKNOWN_APP_SOURCES, packageURI);
                //系统将打开是未知来源应用的管理列表，需要用户手动设置未知来源应用安装权限
                mActivity.startActivityForResult(intent, REQUESE_CODE);
            }
        });
        thread.start();
    }


    public void installApk(String path) {
        Intent var5 = new Intent("android.intent.action.VIEW");
        path = path.startsWith("file://") ? path : "file://" + path;
        var5.setDataAndType(Uri.parse(path), "apk");

        try {
            mActivity.startActivity(var5);
        } catch (Exception var8) {
        }
    }


}


