import 'dart:async';
import 'dart:io';

import 'package:flutter/services.dart';

class RequestInstallPackages {
  static const MethodChannel _channel =
      const MethodChannel('request_install_packages');

  static Future<bool> request() {
    if (!Platform.isAndroid) {
      return Future.value(true);
    }
    return _channel.invokeMethod('request');
  }

  static Future<bool> check() {
    if (!Platform.isAndroid) {
      return Future.value(true);
    }
    return _channel.invokeMethod('check');
  }

  static Future<bool> installApk(String path) {
    if (!Platform.isAndroid) {
      return Future.value(true);
    }
    return _channel.invokeMethod('installApk', {"path": path});
  }
}
